!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
c--- note that p has mxpart entries, pjet has 20
      function deltarj(i,j,p,pjet)
      implicit none
      include 'src/Inc/types.f'
      real(dp):: deltarj
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      real(dp):: p(mxpart,4),pjet(20,4),phi1,phi2,etarap,dphi,
     & etarap20
      integer:: i,j
      
      phi1=atan2(p(i,1),p(i,2))
      phi2=atan2(pjet(j,1),pjet(j,2))
      dphi=phi1-phi2
      if (dphi > pi) dphi=twopi-dphi
      if (dphi < -pi) dphi=twopi+dphi
      deltarj=(etarap(i,p)-etarap20(j,pjet))**2+dphi**2
      deltarj=sqrt(deltarj)
      return
      end

c--- note that p has 20 entries
      function deltarq(i,j,p)
      implicit none
      include 'src/Inc/types.f'
      real(dp):: deltarq
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      real(dp):: p(20,4),phi1,phi2,etarap20,dphi
      integer:: i,j

      phi1=atan2(p(i,1),p(i,2))
      phi2=atan2(p(j,1),p(j,2))
      dphi=phi1-phi2
      if (dphi > pi) dphi=twopi-dphi
      if (dphi < -pi) dphi=twopi+dphi
      deltarq=(etarap20(i,p)-etarap20(j,p))**2+dphi**2
      deltarq=sqrt(deltarq)

      return
      end

c--- note that p has 20 entries
      function etarap20(j,p)
      implicit none
      include 'src/Inc/types.f'
      real(dp):: etarap20
      
C---returns the value of the pseudorapidity
      integer:: j
      real(dp):: p(20,4)
      etarap20=sqrt(p(j,1)**2+p(j,2)**2+p(j,3)**2)
      etarap20=(etarap20+p(j,3))/(etarap20-p(j,3))
      if (etarap20 < 1.e-13_dp) then
C-- set to 100 if this is very close to or less than zero
c-- rapidities of 100 will be rejected by any sensible cuts
      etarap20=100._dp
      else
      etarap20=0.5_dp*log(etarap20)
      endif
      return
      end

