!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine qqb_fourgam_gs(p,msq)
      implicit none
      include 'src/Inc/types.f'
c---Matrix element SUBTRACTION squared averaged over initial colors and spins
c---    q(p1) + q~(p2) --> gam(p3) + gam(p4) + gam(p5) +gam(p6) + g(p7)
c--- (and all crossings)
c---
c--- C. W, Sept 2014
       
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/ptilde.f'
      include 'src/Inc/qqgg.f'
      include 'src/Inc/ewcharge.f'
      include 'src/Inc/frag.f'
      include 'src/Inc/phot_dip.f'
      integer:: j,k,nd
      real(dp):: p(mxpart,4),msq(maxd,-nf:nf,-nf:nf)
      real(dp):: msq17_2(-nf:nf,-nf:nf),msq27_1(-nf:nf,-nf:nf),
     & sub17_2(4),sub27_1(4),dummyv(-nf:nf,-nf:nf),dsubv,
     &  msq37_1(-nf:nf,-nf:nf), msq47_1(-nf:nf,-nf:nf),
     &  msq57_1(-nf:nf,-nf:nf), msq67_1(-nf:nf,-nf:nf),
     &  sub37_1,sub47_1,sub57_1,sub67_1
      external qqb_fourgam,qqb_trigam_g,donothing_gvec

      if (frag) then
         ndmax=6
      else
        ndmax=2
      endif
      
c---- calculate both initial-initial dipoles
c---- note that we do not require the gg dipoles, so the v-type
c---- entries are left as dummies
      call dips(1,p,1,7,2,sub17_2,dsubv,msq17_2,dummyv,
     & qqb_fourgam,donothing_gvec)
      call dips(2,p,2,7,1,sub27_1,dsubv,msq27_1,dummyv,
     & qqb_fourgam,donothing_gvec)
c--- extra photon dipoles in the case of fragmentation
      if (frag) then
         call dipsfrag(3,p,3,7,1,sub37_1,msq37_1,qqb_trigam_g)
         call dipsfrag(4,p,4,7,1,sub47_1,msq47_1,qqb_trigam_g)
         call dipsfrag(5,p,5,7,1,sub57_1,msq57_1,qqb_trigam_g)
         call dipsfrag(6,p,6,7,1,sub67_1,msq67_1,qqb_trigam_g)
         phot_dip(3:6)=.true.
      endif
      
      do j=-nf,nf
      do k=-nf,nf

      do nd=1,ndmax
      msq(nd,j,k)=0d0
      enddo

      if     ((j > 0) .and. (k < 0)
     &    .or.(j < 0) .and. (k > 0)) then
         msq(1,j,k)=2d0*cf*sub17_2(qq)*msq17_2(j,k)
         msq(2,j,k)=2d0*cf*sub27_1(qq)*msq27_1(j,k)
      elseif ((j .ne. 0) .and. (k == 0)) then
         msq(2,j,k)=2d0*tr*sub27_1(qg)*msq27_1(j,-j)
         if (frag) then
            msq(3,j,k)=Q(j)**2*msq37_1(j,k)*sub37_1/4d0
            msq(4,j,k)=Q(j)**2*msq47_1(j,k)*sub47_1/4d0
            msq(5,j,k)=Q(j)**2*msq57_1(j,k)*sub57_1/4d0
            msq(6,j,k)=Q(j)**2*msq67_1(j,k)*sub67_1/4d0
         endif
      elseif ((j == 0) .and. (k .ne. 0)) then
         msq(1,j,k)=2d0*tr*sub17_2(qg)*msq17_2(-k,k)
         if (frag) then
          msq(3,j,k)=Q(k)**2*msq37_1(j,k)*sub37_1/4d0
          msq(4,j,k)=Q(k)**2*msq47_1(j,k)*sub47_1/4d0
          msq(5,j,k)=Q(k)**2*msq57_1(j,k)*sub57_1/4d0
          msq(6,j,k)=Q(k)**2*msq67_1(j,k)*sub67_1/4d0
         endif
      endif

      enddo
      enddo

      return      
      end
