!  Copyright (C) 2019-2020, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine banner
          use m_config, only: cfg_string_len, cfg_get
          use parseinput, only: cfg
      implicit none
      include 'src/Inc/types.f'

      logical, parameter :: prelim = .false.

c--- warning message, if necessary
      if (prelim) then
        write(6,*) '*                                                *'
        write(6,*) '*           PRELIMINARY VERSION                  *'
        write(6,*) '*                                                *'
        write(6,*) '*  NOTE: This is a private release of the MCFM   *'
        write(6,*) '*  code that has not yet been made public on the *'
        write(6,*) '*  usual website. As such:                       *'
        write(6,*) '*                                                *'
        write(6,*) '*   + Please do not redistribute without the     *'
        write(6,*) '*     knowledge of the authors;                  *'
        write(6,*) '*                                                *'
        write(6,*) '*   + Please notify the authors of any bugs      *'
        write(6,*) '*     or problems so that they can be corrected  *'
        write(6,*) '*     before the next official release.          *'
        write(6,*) '*                                                *'
      endif

      write (6,*) '*************** MCFM - version 10.0 **************'
      write (6,*) '*                                                *'
      write (6,*) '* MCFM, v10.0                       March 2021   *'
      write (6,*) '* CuTe-MCFM, v1.0                                *'
      write (6,*) '*                                                *'
      write (6,*) '* On the web: https://mcfm.fnal.gov/             *'
      write (6,*) '*                                                *'
      write (6,*) '* MCFM Authors:                                  *'
      write (6,*) '*                                                *'
      write (6,*) '*  John Campbell <johnmc@fnal.gov>               *'
      write (6,*) '*  Keith Ellis <ellis@fnal.gov>                  *'
      write (6,*) '*  Walter Giele <giele@fnal.gov>                 *'
      write (6,*) '*  Tobias Neumann <tneumann@fnal.gov>            *'
      write (6,*) '*  Ciaran Williams <ciaranwi@buffalo.edu>        *'
      write (6,*) '*                                                *'
      write (6,*) '* CuTe-MCFM Authors:                             *'
      write (6,*) '*                                                *'
      write (6,*) '*  Thomas Becher <becher@itp.unibe.ch>           *'
      write (6,*) '*  Tobias Neumann <tneumann@fnal.gov>            *'
      write (6,*) '*                                                *'
      write (6,*) '* ===== CuTe-MCFM publication =====              *'
      write (6,*) '*                                                *'
      write (6,*) '*  Fiducial qT resummation of color-singlet      *'
      write (6,*) '*  processes at N3LL+NNLO (T. Becher, T.Neumann) *'
      write (6,*) '*    arXiv:2009.11437                            *'
      write (6,*) '*                                                *'
      write (6,*) '* ===== MCFM publications =====                  *'
      write (6,*) '*                                                *'
      write (6,*) '*  Precision phenomenology with MCFM             *'
      write (6,*) '*   J. M. Campbell, T. Neumann                   *'
      write (6,*) '*     arXiv:1909.09117                           *'
      write (6,*) '*   (release publication of MCFM-9.0)            *'
      write (6,*) '*                                                *'
      write (6,*) '*  Color singlet production at NNLO in MCFM      *'
      write (6,*) '*   R. Boughezal, J. Campbell, R.K. Ellis,       *'
      write (6,*) '*    C. Focke, W. Giele, X. Liu, F. Petriello,   *'
      write (6,*) '*    C. Williams,  arXiv:1605.08011              *'
      write (6,*) '*    (overview of NNLO implementation in MCFM)   *'
      write (6,*) '*                                                *'
      write (6,*) '*  A study of weak corrections to Drell-Yan,     *'
      write (6,*) '*   top-quark pair and di-jet production at      *'
      write (6,*) '*    high energies with MCFM                     *'
      write (6,*) '*   J. M. Campbell, D. Wackeroth, J. Zhou,       *'
      write (6,*) '*   arXiv:1608.03356 (weak corrections in MCFM)  *'
      write (6,*) '*                                                *'
      write (6,*) '*  arXiv:1903.11023 (off-shell single top SMEFT) *'
      write (6,*) '*  arXiv:1802.02981 (NLO H+jet high pT mass eff.)*'
      write (6,*) '*  arXiv:1708.02925 (Zgamma at NNLO)             *'
      write (6,*) '*  arXiv:1609.00367 (NLO H+jet with mass effects)*'
      write (6,*) '*  arXiv:1603.02663 (diphotons at NNLO)          *'
      write (6,*) '*  arXiv:1601.00658 (VH at NNLO)                 *'
      write (6,*) '*                                                *'
      write (6,*) '*  arXiv:1502.02990 (VBF and VBS Higgs)          *'
      write (6,*) '*  arXiv:1403.2641  (Triphoton production)       *'
      write (6,*) '*  arXiv:1312.1628  (gg->WW, Higgs interference) *'
      write (6,*) '*  arXiv:1311.3589  (gg->ZZ, Higgs interference) *'
      write (6,*) '*  Phys.Rev.D87:114006, arXiv:1302.3856          *'
      write (6,*) '*  (tZ, tH -- with R. Rontsch)                   *'
      write (6,*) '*  arXiv:1211.6390 (DM, P. Fox and C. Williams)  *'
      write (6,*) '*  JHEP 1211:162 (2012), arXiv:1208.0566         *'
      write (6,*) '*  (Z+gam+jet,Z+gam+gam -- with H. Hartanto)     *'
      write (6,*) '*  arXiv:1204.1513 (top production+decay)        *'
      write (6,*) '*  JHEP 1207:052 (2012), arXiv:1204.5678 (ttW)   *'
      write (6,*) '*  JHEP 1110:005 (2011), arXiv:1107.5569         *'
      write (6,*) '*         (gg->WW,Higgs intference)              *'
      write (6,*) '*  JHEP 1107:018 (2011), arXiv:1105.0020         *'
      write (6,*) '*         (diboson update)                       *'
      write (6,*) '*  JHEP 1103:027 (2011), arXiv:1011.6647         *'
      write (6,*) '*         (Wbb for mb>0, with S. Badger)         *'
      write (6,*) '*  Phys.Rev.D81:074023, arXiv:1001.4495 (H+2jet) *'
      write (6,*) '*                                                *'
      write (6,*) '*  P.R.L. 102:142001, arXiv:0903.0005 [hep-ph]   *'
      write (6,*) '*    (t-channel single top + explicit b,         *'
      write (6,*) '*      JC, R.Frederix, F.Maltoni, F.Tramontano)  *'
      write (6,*) '*  N.P.B 726:109(2005), hep-ph/0506289 (W+t)     *'
      write (6,*) '*  Phys.Rev.D70:094012, hep-ph/0408158 (Sngl Top)*'
      write (6,*) '*       (with Francesco Tramontano)              *'
      write (6,*) '*                                                *'
      write (6,*) '*  Phys.Rev.D65:113007, hep-ph/0202176 (W,Z+2j)  *'
      write (6,*) '*  Phys.Rev.D62:114012, hep-ph/0006304 (W,Z+bb)  *'
      write (6,*) '*  Phys.Rev.D60:113006, hep-ph/9905386 (diboson) *'
      write (6,*) '*                                                *'
      write (6,*) '*  MCFM uses the libraries                       *'
      write (6,*) '*    QCDLoop 2.0.5                               *'
      write (6,*) '*    (S. Carrazza, R.K. Ellis, G. Zanderighi)    *'
      write (6,*) '*                                                *'
      write (6,*) '*    Quad Double 2.3.22                          *'
      write (6,*) '*    (Y. Hida, X.S. Li, D.H. Bailey)             *'
      write (6,*) '*                                                *'
      write (6,*) '**************************************************'

      return
      end








