!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine hbbdecay(p,ib,ibb,msq)
      implicit none
      include 'src/Inc/types.f'
************************************************************************
*     Author: J.M. Campbell, June 2012                                 *
*                                                                      *
*     matrix element squared for the process of                        *
*     Higgs decay  H --> b(ib)+b~(ibb)                                 *
*     with bottom mass included                                        *
************************************************************************
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      integer:: ib,ibb
      real(dp):: p(mxpart,4),s56,msq,msqhbb
      
      s56=2._dp*(p(ib,4)*p(ibb,4)-p(ib,1)*p(ibb,1)
     &        -p(ib,2)*p(ibb,2)-p(ib,3)*p(ibb,3))+2._dp*mb**2
      
      msq=msqhbb(s56)
      
      return
      end
      
      
      
      function msqhbb(s)
      implicit none
      include 'src/Inc/types.f'
      real(dp):: msqhbb
      real(dp):: s
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      include 'src/Inc/couple.f'
      include 'src/Inc/kpart.f'
      include 'src/Inc/msbarmasses.f'
      include 'src/Inc/ewcouple.f'
      include 'src/Inc/first.f'
      include 'src/Inc/hbbparams.f'

      msqhbb=xn*gwsq*mb_eff**2/(4._dp*wmass**2)*2._dp*(s-4._dp*mb**2)

      return
      end
      
      
