!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine phase_realstop(r,p,wt,*)
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/masses.f'
      !include 'src/Inc/limits.f'
      include 'src/Inc/mxdim.f'
      include 'src/Inc/zerowidth.f'
      include 'src/Inc/breit.f'
      include 'src/Inc/x1x2.f'
      include 'src/Inc/phasemin.f'
      include 'src/Inc/energy.f'
      include 'src/Inc/limits.f'

      real(dp), intent(in) :: r(mxdim)
      real(dp), intent(out) :: p(mxpart,4), wt

      real(dp) :: p1(4),p2(4),p3(4),p4(4),p5(4),p6(4),p7(4)
      real(dp) :: p12(4),p126(4),p34(4),p345(4)
      real(dp) :: wt0,wt1,wt2,wt3,wt4
      real(dp) :: smin

      real(dp) :: tau,y,xjac
      
      parameter(wt0=1._dp/twopi**2)

      smin = 0._dp

      tau=exp(log(taumin)*r(12))
      y=0.5_dp*log(tau)*(1._dp-2._dp*r(13))
      xjac=log(taumin)*tau*log(tau)

      xx(1)=sqrt(tau)*exp(+y)
      xx(2)=sqrt(tau)*exp(-y)

      if   ((xx(1) > 1._dp) 
     & .or. (xx(2) > 1._dp)) return 1

      p1(4)=-xx(1)*sqrts*half
      p1(1)=zip
      p1(2)=zip
      p1(3)=-xx(1)*sqrts*half

      p2(4)=-xx(2)*sqrts*half
      p2(1)=zip
      p2(2)=zip
      p2(3)=+xx(2)*sqrts*half

      p12 = -p1-p2
      call phi1_2m(0._dp,r(1),r(2),r(3),smin,p12,p6,p126,wt1,*99)
      call phi1_2m_bw(0._dp,r(4),r(5),r(6),smin,p126,p7,p345,mt,twidth,wt2,*99)
      call phi1_2m_bw(0._dp,r(7),r(8),r(9),smin,p345,p5,p34,wmass,wwidth,wt3,*99)
      call phi3m0(r(10),r(11),p34,p3,p4,wt4,*99)

      wt = xjac*wt0*wt1*wt2*wt3*wt4

      p = 0._dp
      p(1,:) = p1
      p(2,:) = p2
      p(3,:) = p3
      p(4,:) = p4
      p(5,:) = p5
      p(6,:) = p6
      p(7,:) = p7

      return

 99   wt=0._dp
      return 1
      end

