!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine qqb_tottth_g(p,msq)
      implicit none
      include 'src/Inc/types.f'
      
************************************************************************
*     Author: R.K. Ellis                                               *
*     May, 2013.                                                       *
*     calculate the element squared                                    *
*     for the process                                                  *
*----My notation                                                       *
*     q(-p1) +qbar(-p2)=t(p3)+t(p4)+h(p5)+g(p6)                        *
*                                                                      *
************************************************************************
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/ewcouple.f'
      include 'src/Inc/qcdcouple.f'
      include 'src/Inc/couple.f'
      include 'src/Inc/kpart.f'
      include 'src/Inc/masses.f'
      include 'src/Inc/swapxz.f'
      include 'src/Inc/msbarmasses.f'
      include 'src/Inc/first.f'
      
      integer:: j,k
      real(dp):: msq(-nf:nf,-nf:nf),p(mxpart,4)
      real(dp):: wtqqb,wtgg,wtqbq,wtqg,wtqbg,wtgq,wtgqb
      real(dp):: massfrun,mt_eff,ytsq,fac
      save mt_eff
!$omp threadprivate(mt_eff) 
      if (first) then
c--- run mt to appropriate scale
        if (kpart==klord) then
          mt_eff=massfrun(mt_msbar,hmass,amz,1)
        else
          mt_eff=massfrun(mt_msbar,hmass,amz,2)
        endif
        first=.false.
      endif

      call ttgggHdriver(p,wtgg)
      ytsq=0.5d0*gwsq*(mt_eff/wmass)**2
      fac=V*gsq**3*ytsq/16d0

      call ttqqgHampsq(p,3,4,2,1,6,1,1,wtqbq)
      call ttqqgHampsq(p,3,4,1,2,6,1,1,wtqqb)
      call ttqqgHampsq(p,3,4,2,6,1,1,1,wtgq)
      call ttqqgHampsq(p,3,4,6,2,1,1,1,wtgqb)
      call ttqqgHampsq(p,3,4,1,6,2,1,1,wtqg)
      call ttqqgHampsq(p,3,4,6,1,2,1,1,wtqbg)

C----set all elements to zero
      do j=-nf,nf
      do k=-nf,nf
      msq(j,k)=0d0
      enddo
      enddo

      do j=-nf,nf
      do k=-nf,nf
      if     ((j > 0) .and. (k == -j)) then
          msq(j,k)=aveqq*fac*wtqqb             !qqb
      elseif ((j < 0) .and. (k == -j)) then
          msq(j,k)=aveqq*fac*wtqbq             !qbq

      elseif ((j == 0) .and. (k > 0)) then
          msq(j,k)=aveqg*fac*wtgq              !gq
      elseif ((j == 0) .and. (k < 0)) then
          msq(j,k)=aveqg*fac*wtgqb             !gqb
      elseif ((j > 0) .and. (k == 0)) then
          msq(j,k)=aveqg*fac*wtqg              !qg
      elseif ((j < 0) .and. (k ==0)) then
          msq(j,k)=aveqg*fac*wtqbg             !qbg

      elseif ((j == 0)  .and. (k == 0)) then
          msq(j,k)=avegg*fac*wtgg        !gg
      endif
      enddo
      enddo
      return
      end
 
