!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine ttggHsingdriver(q,ampsq)
      implicit none
      include 'src/Inc/types.f'
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/epinv.f'
      real(dp):: q(mxpart,4),ampsq
      integer:: h1,h2,h3,h4
      complex(dp):: cab(-2:-1),cba(-2:-1),c00ab(-2:-1),c00ba(-2:-1),
     & ampAB(2,2,2,2),ampBA(2,2,2,2),
     & ampABs(2,2,2,2),ampBAs(2,2,2,2),ampABd(2,2,2,2),ampBAd(2,2,2,2),
     & tmp

      call ttggHamp(q,3,4,1,2,1,1,ampAB)
      call ttggHamp(q,3,4,2,1,1,1,ampBA)
      call singcoeffg(q,3,4,1,2,cab,cba,c00ab,c00ba)

      do h1=1,2
      do h2=1,2
      h3=1
      h4=2
      tmp=ampBA(h1,h2,h3,h4)
      ampBA(h1,h2,h3,h4)=ampBA(h1,h2,h4,h3)
      ampBA(h1,h2,h4,h3)=tmp
      enddo
      enddo
      

      do h1=1,2
      do h2=1,2
      do h3=1,2
      do h4=1,2
      ampABs(h1,h2,h3,h4)=
     & +cab(-2)*epinv**2*ampAB(h1,h2,h3,h4)
     & +cab(-1)*epinv*ampAB(h1,h2,h3,h4)
      ampBAs(h1,h2,h3,h4)=
     & +cba(-2)*epinv**2*ampBA(h1,h2,h3,h4)
     & +cba(-1)*epinv*ampBA(h1,h2,h3,h4)
      ampABd(h1,h2,h3,h4)=
     & +c00ab(-2)*epinv**2*ampAB(h1,h2,h3,h4)
     & +c00ab(-1)*epinv*ampAB(h1,h2,h3,h4)
      ampBAd(h1,h2,h3,h4)=
     & +c00ba(-2)*epinv**2*ampBA(h1,h2,h3,h4)
     & +c00ba(-1)*epinv*ampBA(h1,h2,h3,h4)
      enddo
      enddo
      enddo
      enddo

      ampsq=0d0
      do h1=1,2
      do h2=1,2
      do h3=1,2
      do h4=1,2
c  V*xn/4*(cab*mab*mabC+cba*mba*mbaC)
c  +V * ( 1/2*c00ba*mba*(mbaC+mabC)
c        +1/2*c00ab*mab*(mbaC+mabC))
c  -V/xn * (1/4*cba*mba*(mbaC+mabC)
c          +1/4*cab*mab*(mbaC+mabC));
C-----Factor of V*xn/4 removed
      ampsq=ampsq
     & +real(ampABs(h1,h2,h3,h4)*conjg(ampAB(h1,h2,h3,h4)))
     & +real(ampBAs(h1,h2,h3,h4)*conjg(ampBA(h1,h2,h3,h4)))
     & +2d0/xn*real((ampABd(h1,h2,h3,h4)+ampBAd(h1,h2,h3,h4))
     &  *conjg(ampAB(h1,h2,h3,h4)+ampBA(h1,h2,h3,h4)))
     & -1d0/xn**2*real((ampABs(h1,h2,h3,h4)+ampBAs(h1,h2,h3,h4))
     &  *conjg(ampAB(h1,h2,h3,h4)+ampBA(h1,h2,h3,h4)))
      enddo
      enddo
      enddo
      enddo
      return
      end
