!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function BSYA1lcqqppmp(e1,p2,p3,e4,za,zb,zab,zba)
      implicit none
      include 'src/Inc/types.f'
      complex(dp):: BSYA1lcqqppmp
      
C-----Authors: John Campbell and Keith Ellis, March 2012
C---- arXiv:1101.5947 [hep-ph], Eq. (98), fully Badger-compliant
C---- (These are twiddle functions, c.f.arXiv:1101.5947[hep-ph],Eq.(91))
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      include 'src/Inc/zabprods_decl.f'
      include 'src/Inc/qdef.f'
      include 'src/Inc/massiveintegrals.f'
      real(dp):: xbeta2,xbeta4,s12,s23,mt2,mt3
      complex(dp):: BSYA0qqppmp,A0qqppmp,bracket
      integer:: e1,p2,p3,e4,j
 
      j=p2-1

      mt2=mt**2
      mt3=mt**3
      s12=mt2+s(1,p2)
      s23=s(p2,p3)
      xbeta2=1d0-4d0*mt**2/s23
      xbeta4=xbeta2**2

      A0qqppmp=BSYA0qqppmp(e1,p2,p3,e4,za,zb,zab,zba)
      bracket=2d0*zab(p2,q1,p2)+s23

      BSYA1lcqqppmp=A0qqppmp*(
     & 0.5d0*s23*zab(p2,q1,p2)*I41x2x3x4(j)-0.5d0*s23*I32x3x41
     & +zab(p2,q1,p2)*I312x3x4(j)  
     & -(s23+3d0*mt2*bracket/(s23*xbeta4))*I31x23x4
     & -8d0/3d0*I2m+23d0/9d0
     & +12d0*mt2*bracket/(s23**2*xbeta4)   
     & -(7d0/6d0+bracket/(2d0*s23*xbeta2) 
     & +6d0*mt2*bracket/(s23**2*xbeta4))*I2h23)
 
     & +mt*(za(p2,e1)*za(p2,e4)*zb(p2,p3)+za(e1,e4)*zab(p2,q1,p3))
     & /(2d0*zab(p2,q1,p3)**2) 
     & *(zab(p2,q1,p2)**3*I41x2x3x4(j)-zab(p2,q1,p2)**2*I32x3x41  
     & -2d0*zab(p2,q1,p2)**3/s23*I312x3x4(j)
     & +(s12*s23-2d0*mt2*zab(p2,q1,p2))*I31x23x4)

     & +(I31x23x4+2d0/s23*(I2h23-2d0))
     & *(6d0*mt3*(za(p3,e1)*za(p3,e4)*zab(p2,q1,p2)**2
     & +za(p2,e1)*za(p2,e4)*zab(p3,q1,p2)**2)
     & /(za(p2,p3)*s23**2*xbeta4)  
     & -6d0*mt3*za(p2,e1)*za(p3,e4)*zab(p3,q1,p2)
     & *bracket/(za(p2,p3)*s23**2*xbeta4)
     & -3d0*mt3*za(p3,e1)*za(p3,e4)/(2d0*za(p2,p3)*xbeta4))

     & -(I2h23-2d0)*(
     & mt*za(p2,e1)*za(p2,e4)*zab(p3,q1,p2)*(zab(p2,q1,p2)+2d0*mt2)
     & /(za(p2,p3)*zab(p2,q1,p3)*s23*xbeta2) 
     & +2d0*mt*za(p2,e1)*za(p3,e4)*zab(p3,q1,p2)/(za(p2,p3)*s23*xbeta2)
     & -mt*za(p3,e1)*za(p3,e4)*s12/(za(p2,p3)*s23*xbeta2))

     &  +I31x23x4*(
     &  mt*(za(p2,e1)*za(p2,e4)*zab(p3,q1,p2)
     & +za(p3,e1)*za(p3,e4)*zab(p2,q1,p3))*zb(p2,p3) 
     &  /(2d0*zab(p2,q1,p3) )  
     & +mt3*za(p3,e1)*za(p3,e4)*(4d0*zab(p2,q1,p2)+s23)
     & /(2d0*za(p2,p3)*s23*xbeta2) 
     & -mt3*za(p2,e1)*za(p2,e4)*zab(p3,q1,p2)*bracket
     & /(za(p2,p3)*zab(p2,q1,p3)*s23*xbeta2)   
     & -4d0*mt3*za(p2,e1)*za(p3,e4)*zab(p3,q1,p2)
     & /(za(p2,p3)*s23*xbeta2))

     &  + I2h23*(
     &  mt*(za(p3,e1)*za(p3,e4)*zab(p2,q1,p2)**2
     &  +za(p2,e1)*za(p2,e4)*zab(p3,q1,p2)**2) 
     & /(za(p2,p3)*s23**2*xbeta2)   
     &  -mt*za(p2,e1)*za(p3,e4)*zab(p3,q1,p2)*bracket 
     & /(za(p2,p3)*s23**2*xbeta2)
     & -mt3*za(p3,e1)*za(p3,e4)/(za(p2,p3)*s23*xbeta2))

     &  + F212(j)*( 
     & (mt*za(p2,e1)*za(p2,e4)*zab(p3,q1,p2)**2)
     & /(s23*za(p2,p3)*zab(p2,q1,p2))
     & +(mt*za(p2,e1)*za(p2,e4)*zab(p2,q1,p2)*zab(p3,q1,p2))
     & /(s23*za(p2,p3)*zab(p2,q1,p3))
     & -(mt*za(p3,e4)*(za(p2,e1)*zab(p3,q1,p2)+mt2*za(p3,e1))) 
     & /(za(p2,p3)*zab(p2,q1,p2)))
C---  overall sign change as required by the LHS of eq. (98) 
      BSYA1lcqqppmp=-BSYA1lcqqppmp
      
      return
      end
