!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine gluegen(e1,p2,p3,e4,za,zb,zab,zba,pppp,ppmp,lo23,lo32,
     & calculateboth)
      implicit none
      include 'src/Inc/types.f'
      
C-----Authors: John Campbell and Keith Ellis, November 2011
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/zabprods_decl.f'
      complex(dp):: lo23(2,2),lo32(2,2),pppp,ppmp
      integer:: e1,p2,p3,e4,e1p,e4p
      logical:: calculateboth
C---we are calculating the amplitudes mxyp where x=1,2 and y=1,2
C---from our two base amplitudes which are pppp,ppmp

c--- perform the swaps 5 <-> 7 and 6 <-> 8     
      e1p=12-e1
      e4p=14-e4      

c--- JC: added minus signs here based on form of tree level amplitudes
c---     (complex conjugation = (-1) * [za <-> zb])

c-----mmmp
      lo23(1,1)=-pppp(e1,p2,p3,e4p,zb,za,zba,zab)
c-----mppp
      lo23(2,2)=+pppp(e1p,p2,p3,e4,za,zb,zab,zba)
c-----mpmp
      lo23(2,1)=+ppmp(e1p,p2,p3,e4,za,zb,zab,zba)
c-----mmpp
      lo23(1,2)=-ppmp(e1,p2,p3,e4p,zb,za,zba,zab)

c--- alternate return if calculating A43
      if (calculateboth .eqv. .false.) then
        lo32(1,1)=lo23(1,1)
        lo32(1,2)=lo23(1,2)
        lo32(2,1)=lo23(2,1)
        lo32(2,2)=lo23(2,2)
        return
      endif
      
c-----mmmp
      lo32(1,1)=-pppp(e1,p3,p2,e4p,zb,za,zba,zab)
c-----mppp
      lo32(2,2)=+pppp(e1p,p3,p2,e4,za,zb,zab,zba)
c-----mpmp
      lo32(1,2)=+ppmp(e1p,p3,p2,e4,za,zb,zab,zba)
c-----mmpp
      lo32(2,1)=-ppmp(e1,p3,p2,e4p,zb,za,zba,zab)

      return
      end
