!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine epem3j(p,msq)
      implicit none
      include 'src/Inc/types.f'
      
c--- simple modification of qqb_w_g.f: permuted 1 and 4, 2 and 3
c--- to switch leptons with quarks and added a factor of Nc      
      
c----Matrix element for W production
C----averaged over initial colours and spins
C for nwz=+1
c     u(-p1)+dbar(-p2)--> W^+(n(p3)+e^+(p4))   + g(p5)
C For nwz=-1
c     d(-p1)+ubar(-p2)--> W^-(e^-(p3)+nbar(p4))+ g(p5) 
c---
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/ewcouple.f'
      include 'src/Inc/qcdcouple.f'
      include 'src/Inc/sprods_com.f'
      integer:: j,k
      real(dp):: msq(-nf:nf,-nf:nf),p(mxpart,4),fac
      real(dp):: qqbWg,qbqWg,qgWq,qbgWqb,gqbWqb,gqWq,w1jet
     
c--- initialize
      msq(:,:)=zip

      call dotem(5,p,s)
c---calculate the propagator
      fac=gwsq**2*gsq*V*xn

      qqbWg= +aveqq*fac*w1jet(4,3,2,1,5)

c--- put result in msq(0,0) element for LO and real, fill the other
c--- elements too to make sure that the virtual CT's work as well
      msq(0,0)=qqbWg
      msq(1,0)=msq(0,0)
      msq(0,1)=msq(0,0)
      
      return
      end
 
