!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine aqaqHamp(p1,p2,p3,p4,za,zb,amp)
!     Implementation of Eq.~(11.6) from arXiv:2002.04018 v2
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      integer::p1,p2,p3,p4
      complex(dp)::FL,FT,zab2,zba2,amp(2,2)
      real(dp)::ssum,sprod
      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)
      zba2(p1,p2,p3,p4)=zb(p1,p2)*za(p2,p4)+zb(p1,p3)*za(p3,p4)
      
      sprod=s(p1,p2)*s(p3,p4)
      ssum=s(p2,p4)+s(p2,p3)+s(p1,p4)+s(p1,p3)
      call fillformfactor(p1,p2,p3,p4,FL,FT)
      amp(1,1)=2._dp*FL*za(p2,p4)*zb(p1,p3)
     & +FT/sprod*(zab2(p2,p4,p3,p1)*zab2(p4,p2,p1,p3)
     & +za(p2,p4)*zb(p1,p3)*ssum)
      amp(2,2)=2._dp*FL*za(p1,p3)*zb(p2,p4)
     & +FT/sprod*(zba2(p2,p4,p3,p1)*zba2(p4,p2,p1,p3)
     & +za(p1,p3)*zb(p2,p4)*ssum)
      amp(1,2)=2._dp*FL*za(p2,p3)*zb(p1,p4)
     & +FT/sprod*(zab2(p2,p4,p3,p1)*zba2(p4,p2,p1,p3)
     & +za(p2,p3)*zb(p1,p4)*ssum)
      amp(2,1)=2._dp*FL*za(p1,p4)*zb(p2,p3)
     & +FT/sprod*(zab2(p4,p2,p1,p3)*zba2(p2,p4,p3,p1)
     & +za(p1,p4)*zb(p2,p3)*ssum)
      return
      end
