!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function aqpmpmB123(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_qb^+ 2_q^- 3_g^+ 4_g^- +H
!     Implementation of Eq.~(10.4) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      integer p1,p2,p3,p4
      real(dp):: s12,s13,s14,s23,s24,s34,s123,s14p24p34
      complex(dp):: zab2,aqpmpmB123

      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)

      s123=s12+s13+s23
      s14p24p34=s14+s24+s34

      aqpmpmB123 =4*s123*(
     &  zb(p1,p3)*za(p2,p3)
     & /(zab2(p3,p1,p2,p3)*zab2(p3,p1,p2,p4)**2)
     & -za(p2,p4)**2*zab2(p2,p1,p3,p4)
     & /(za(p1,p2)*za(p2,p3)*zab2(p3,p1,p2,p4)*s14p24p34**2)
     &  -za(p2,p4)*zab2(p2,p1,p3,p4)
     & /(za(p1,p2)*zab2(p3,p1,p2,p4)**2*s14p24p34))

      return
      end
