!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine haqgg_pmpm(p1,p2,p3,p4,za,zb,Amp)
c--- Coefficients of basis integrals in the helicity amplitude for
c----0 -> qb+(p1) + q-(p2) + g+(p3) + g-(p4) + h
c--- with full top mass dependence
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/constants.f'
      include 'src/ggHgg_mass/hgggglabels.f'
      include 'src/ggHgg_mass/IntResults.f'
      include 'src/Inc/zprods_decl.f'
      integer p1,p2,p3,p4
      complex(dp) :: Dcoeff(dmax),Ccoeff(cmax),Bcoeff(bmax),Rat,Amp,
     & R(cmax),aqmpD4x3x21,aqmpD3x21x4,
     & aqmpC3x12,aqmpC3x4,aqmpC12x34,aqpmC4x123,
     & aqpmmpB34,aqmpB12,aqpmpmB123

      Dcoeff(:)=czip
      Ccoeff(:)=czip
      Bcoeff(:)=czip
      
      Dcoeff(d3x4x12)=-aqmpD4x3x21(p1,p2,p4,p3,za,zb)
      Dcoeff(d4x3x21)=+aqmpD4x3x21(p2,p1,p3,p4,zb,za)
      Dcoeff(d4x12x3)=+aqmpD3x21x4(p2,p1,p3,p4,zb,za)

      Ccoeff(c3x21)=+aqmpC3x12(p2,p1,p3,p4,zb,za)
      Ccoeff(c4x12)=-aqmpC3x12(p1,p2,p4,p3,za,zb)
      Ccoeff(c3x4)=+aqmpC3x4(p2,p1,p3,p4,zb,za)
      Ccoeff(c12x34)=+aqmpC12x34(p2,p1,p3,p4,zb,za,R(c12x34))

      Ccoeff(c4x123)=aqpmC4x123(p1,p2,p3,p4,za,zb,R(c4x123))
      Ccoeff(c3x412)=-aqpmC4x123(p2,p1,p4,p3,zb,za,R(c3x412))

      Bcoeff(b12)=+aqmpB12(p2,p1,p3,p4,zb,za)
      Bcoeff(b123)=+aqpmpmB123(p1,p2,p3,p4,za,zb)
      Bcoeff(b412)=-aqpmpmB123(p2,p1,p4,p3,zb,za)
      Bcoeff(b34)=+aqpmmpB34(p2,p1,p3,p4,zb,za)
      Bcoeff(b1234)=-Bcoeff(b12)-Bcoeff(b34)-Bcoeff(b123)-Bcoeff(b412)

!      Rat=
!     &-(-aqmpC12x34m2(p2,p1,p3,p4,zb,za) 
!     &  -aqpmC4x123m2(p1,p2,p3,p4,za,zb)
!     &  +aqpmC4x123m2(p2,p1,p4,p3,zb,za))/two

      Rat=0.5_dp*(R(c12x34)+R(c4x123)-R(c3x412))

      Amp=
     & +Dcoeff(d3x4x12)*Dint(6)
     & +Dcoeff(d4x3x21)*Dint(8)
     & +Dcoeff(d4x12x3)*Dint(12)
     & +Ccoeff(c12x34)*Cint(5)
     & +Ccoeff(c3x21)*Cint(11)
     & +Ccoeff(c3x412)*Cint(3)
     & +Ccoeff(c4x12)*Cint(13)
     & +Ccoeff(c3x4)*Cint(17)
     & +Ccoeff(c4x123)*Cint(4)
     & +Bcoeff(b1234)*Bint(9)+Bcoeff(b12)*Bint(5)
     & +Bcoeff(b34)*Bint(7)
     & +Bcoeff(b412)*Bint(4)+Bcoeff(b123)*Bint(1)
     & +Rat

      return
      end
