!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine hgggg_integralfill(p1,p2,p3,p4)
      use mod_qcdloop_c
      use iso_c_binding
      use iso_fortran_env
      implicit none
! calculation of the integrals needed order results but into arrays (e.g. Dint)
      include 'src/Inc/types.f'
      include 'src/Inc/constants.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/sprods_com.f'
      include 'src/ggHgg_mass/mtsq.f'
      include 'src/ggHgg_mass/hgggglabels.f'
      include 'src/ggHgg_mass/IntResults.f'
      integer p1,p2,p3,p4
      real(dp):: s12,s13,s14,s23,s24,s34,s123,s124,s134,s234,Mhsq,mu2
      real(real128):: s12_128,s13_128,s14_128,s23_128,s24_128,s34_128,
     & s123_128,s124_128,s134_128,s234_128,Mhsq_128
      real(real128):: mtsq_128,mu2_128,zip_128
      logical, parameter :: doquad=.false. ! Compute integrals in quad prec?

! Dummy scale: there is no dependence on this in the result (it is finite)
      mu2=mtsq

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      s123=s12+s13+s23
      s124=s12+s14+s24
      s234=s23+s24+s34
      s134=s13+s14+s34
      Mhsq=s12+s13+s14+s23+s24+s34

! Boxes
      Dint(1)= qlI4(zip,zip,s34,Mhsq,s12,s234,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(2)= qlI4(zip,zip,s23,Mhsq,s14,s234,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(3)= qlI4(zip,zip,s34,Mhsq,s12,s134,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(4)= qlI4(zip,zip,s14,Mhsq,s23,s134,mtsq,mtsq,mtsq,mtsq,mu2,0)

      Dint(5)= qlI4(zip,zip,s14,Mhsq,s23,s124,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(6)= qlI4(Mhsq,zip,zip,s12,s124,s34,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(7)= qlI4(zip,zip,s23,Mhsq,s14,s123,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(8)= qlI4(Mhsq,zip,zip,s12,s123,s34,mtsq,mtsq,mtsq,mtsq,mu2,0)

      Dint(9)=qlI4(zip,s34,zip,Mhsq,s134,s234,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(10)=qlI4(zip,s23,zip,Mhsq,s123,s234,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(11)=qlI4(zip,s14,zip,Mhsq,s124,s134,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(12)=qlI4(zip,Mhsq,zip,s12,s123,s124,mtsq,mtsq,mtsq,mtsq,mu2,0)

      Dint(13)=qlI4(zip,zip,zip,s124,s14,s12,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(14)=qlI4(zip,zip,zip,s123,s12,s23,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(15)=qlI4(zip,zip,zip,s134,s34,s14,mtsq,mtsq,mtsq,mtsq,mu2,0)
      Dint(16)=qlI4(zip,zip,zip,s234,s23,s34,mtsq,mtsq,mtsq,mtsq,mu2,0)


! Triangles
      Cint(1)=qlI3(s234,zip,Mhsq,mtsq,mtsq,mtsq,mu2,0)
      Cint(2)=qlI3(s134,zip,Mhsq,mtsq,mtsq,mtsq,mu2,0)
      Cint(3)=qlI3(s124,zip,Mhsq,mtsq,mtsq,mtsq,mu2,0)
      Cint(4)=qlI3(s123,zip,Mhsq,mtsq,mtsq,mtsq,mu2,0)

      Cint(5)=qlI3(s34,Mhsq,s12,mtsq,mtsq,mtsq,mu2,0)
      Cint(6)=qlI3(s23,Mhsq,s14,mtsq,mtsq,mtsq,mu2,0)

      Cint(7)=qlI3(s23,s123,zip,mtsq,mtsq,mtsq,mu2,0)
      Cint(8)=qlI3(s34,s134,zip,mtsq,mtsq,mtsq,mu2,0)
      Cint(9)=qlI3(s34,s234,zip,mtsq,mtsq,mtsq,mu2,0)
      Cint(10)=qlI3(s14,s124,zip,mtsq,mtsq,mtsq,mu2,0)

      Cint(11)=qlI3(s12,s123,zip,mtsq,mtsq,mtsq,mu2,0)
      Cint(12)=qlI3(s14,s134,zip,mtsq,mtsq,mtsq,mu2,0)
      Cint(13)=qlI3(s12,s124,zip,mtsq,mtsq,mtsq,mu2,0)
      Cint(14)=qlI3(s23,s234,zip,mtsq,mtsq,mtsq,mu2,0)

      Cint(15)=qlI3(s12,zip,zip,mtsq,mtsq,mtsq,mu2,0)
      Cint(16)=qlI3(s23,zip,zip,mtsq,mtsq,mtsq,mu2,0)
      Cint(17)=qlI3(s34,zip,zip,mtsq,mtsq,mtsq,mu2,0)
      Cint(18)=qlI3(s14,zip,zip,mtsq,mtsq,mtsq,mu2,0)

! Bubbles
      Bint(1)=qlI2(s123,mtsq,mtsq,mu2,0)
      Bint(2)=qlI2(s234,mtsq,mtsq,mu2,0)
      Bint(3)=qlI2(s134,mtsq,mtsq,mu2,0)
      Bint(4)=qlI2(s124,mtsq,mtsq,mu2,0)

      Bint(5)=qlI2(s12,mtsq,mtsq,mu2,0)
      Bint(6)=qlI2(s23,mtsq,mtsq,mu2,0)
      Bint(7)=qlI2(s34,mtsq,mtsq,mu2,0)
      Bint(8)=qlI2(s14,mtsq,mtsq,mu2,0)

      Bint(9)=qlI2(Mhsq,mtsq,mtsq,mu2,0)

      if (doquad) then

      s12_128=real(s12,kind=real128)
      s13_128=real(s13,kind=real128)
      s14_128=real(s14,kind=real128)
      s23_128=real(s23,kind=real128)
      s24_128=real(s24,kind=real128)
      s34_128=real(s34,kind=real128)
      s123_128=real(s123,kind=real128)
      s124_128=real(s124,kind=real128)
      s234_128=real(s234,kind=real128)
      s134_128=real(s134,kind=real128)
      Mhsq_128=real(Mhsq,kind=real128)

      mtsq_128 =real(mtsq,kind=real128)
      mu2_128=real(mu2,kind=real128)
      zip_128=real(0.,kind=real128)

! Boxes
      Dint(1)= qlI4q(zip_128,zip_128,s34_128,Mhsq_128,s12_128,s234_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(2)= qlI4q(zip_128,zip_128,s23_128,Mhsq_128,s14_128,s234_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(3)= qlI4q(zip_128,zip_128,s34_128,Mhsq_128,s12_128,s134_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(4)= qlI4q(zip_128,zip_128,s14_128,Mhsq_128,s23_128,s134_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)

      Dint(5)= qlI4q(zip_128,zip_128,s14_128,Mhsq_128,s23_128,s124_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(6)= qlI4q(Mhsq_128,zip_128,zip_128,s12_128,s124_128,s34_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(7)= qlI4q(zip_128,zip_128,s23_128,Mhsq_128,s14_128,s123_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(8)= qlI4q(Mhsq_128,zip_128,zip_128,s12_128,s123_128,s34_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)

      Dint(9)=qlI4q(zip_128,s34_128,zip_128,Mhsq_128,s134_128,s234_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(10)=qlI4q(zip_128,s23_128,zip_128,Mhsq_128,s123_128,s234_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(11)=qlI4q(zip_128,s14_128,zip_128,Mhsq_128,s124_128,s134_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(12)=qlI4q(zip_128,Mhsq_128,zip_128,s12_128,s123_128,s124_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)

      Dint(13)=qlI4q(zip_128,zip_128,zip_128,s124_128,s14_128,s12_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(14)=qlI4q(zip_128,zip_128,zip_128,s123_128,s12_128,s23_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(15)=qlI4q(zip_128,zip_128,zip_128,s134_128,s34_128,s14_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Dint(16)=qlI4q(zip_128,zip_128,zip_128,s234_128,s23_128,s34_128,mtsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)


! Triangles
      Cint(1)=qlI3q(s234_128,zip_128,Mhsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(2)=qlI3q(s134_128,zip_128,Mhsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(3)=qlI3q(s124_128,zip_128,Mhsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(4)=qlI3q(s123_128,zip_128,Mhsq_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)

      Cint(5)=qlI3q(s34_128,Mhsq_128,s12_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(6)=qlI3q(s23_128,Mhsq_128,s14_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)

      Cint(7)=qlI3q(s23_128,s123_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(8)=qlI3q(s34_128,s134_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(9)=qlI3q(s34_128,s234_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(10)=qlI3q(s14_128,s124_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)

      Cint(11)=qlI3q(s12_128,s123_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(12)=qlI3q(s14_128,s134_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(13)=qlI3q(s12_128,s124_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(14)=qlI3q(s23_128,s234_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)

      Cint(15)=qlI3q(s12_128,zip_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(16)=qlI3q(s23_128,zip_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(17)=qlI3q(s34_128,zip_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)
      Cint(18)=qlI3q(s14_128,zip_128,zip_128,mtsq_128,mtsq_128,mtsq_128,mu2_128,0)

! Bubbles
      Bint(1)=qlI2q(s123_128,mtsq_128,mtsq_128,mu2_128,0)
      Bint(2)=qlI2q(s234_128,mtsq_128,mtsq_128,mu2_128,0)
      Bint(3)=qlI2q(s134_128,mtsq_128,mtsq_128,mu2_128,0)
      Bint(4)=qlI2q(s124_128,mtsq_128,mtsq_128,mu2_128,0)

      Bint(5)=qlI2q(s12_128,mtsq_128,mtsq_128,mu2_128,0)
      Bint(6)=qlI2q(s23_128,mtsq_128,mtsq_128,mu2_128,0)
      Bint(7)=qlI2q(s34_128,mtsq_128,mtsq_128,mu2_128,0)
      Bint(8)=qlI2q(s14_128,mtsq_128,mtsq_128,mu2_128,0)

      Bint(9)=qlI2q(Mhsq_128,mtsq_128,mtsq_128,mu2_128,0)

      endif
      
      return
      end
