!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine hgggg_mass(i1,i2,i3,i4,msq)
! Matrix element squared for the procoess
!  g(i1) + g(i2) -> H + g(i3) + g(i4)
! with full top mass dependence retained
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/constants.f'
      include 'src/Inc/zprods_com.f'
      include 'src/ggHgg_mass/hgggglabels.f'
      include 'src/ggHgg_mass/IntResults.f'
      include 'src/Inc/masses.f'
      include 'src/ggHgg_mass/mtsq.f'
      include 'src/Inc/ewcouple.f'
      include 'src/Inc/qcdcouple.f'
      integer i1,i2,i3,i4,j,c1,c2,c3,c4,pppm,ppmm,h1,h2,h3,h4
      real(dp):: msq
      complex(dp) :: Dcoeff(dmax),Ccoeff(cmax),Bcoeff(bmax),Rat,
     & hgggg_assemble,amp(2,2,2,2,3)

      mtsq=mt**2
      
      call fillpenttobox

! Loop over non-cyclic color orderings
      do j=1,3
        if (j == 1) then
          c1=1; c2=2; c3=3; c4=4
        elseif (j == 2) then
          c1=1; c2=3; c3=4; c4=2
        elseif (j == 3) then
          c1=1; c2=4; c3=2; c4=3
        endif

! Permutation (1,2,3,4)
        call hgggg_integralfill(c1,c2,c3,c4)
        call hgggg_pppp(c1,c2,c3,c4,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(2,2,2,2,j)=hgggg_assemble(Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(1,1,1,1,j)=hgggg_assemble(conjg(Dcoeff),conjg(Ccoeff),conjg(Bcoeff),conjg(Rat))

        call hgggg_pppm(c1,c2,c3,c4,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(pppm(1,c4),pppm(2,c4),pppm(3,c4),pppm(4,c4),j)=hgggg_assemble(Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(3-pppm(1,c4),3-pppm(2,c4),3-pppm(3,c4),3-pppm(4,c4),j)=hgggg_assemble(conjg(Dcoeff),conjg(Ccoeff),conjg(Bcoeff),conjg(Rat))

        call hgggg_pmpm(c1,c2,c3,c4,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(ppmm(1,c2,c4),ppmm(2,c2,c4),ppmm(3,c2,c4),ppmm(4,c2,c4),j)=hgggg_assemble(Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(3-ppmm(1,c2,c4),3-ppmm(2,c2,c4),3-ppmm(3,c2,c4),3-ppmm(4,c2,c4),j)=hgggg_assemble(conjg(Dcoeff),conjg(Ccoeff),conjg(Bcoeff),conjg(Rat))

        call hgggg_ppmm(c1,c2,c3,c4,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(ppmm(1,c3,c4),ppmm(2,c3,c4),ppmm(3,c3,c4),ppmm(4,c3,c4),j)=hgggg_assemble(Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(3-ppmm(1,c3,c4),3-ppmm(2,c3,c4),3-ppmm(3,c3,c4),3-ppmm(4,c3,c4),j)=hgggg_assemble(conjg(Dcoeff),conjg(Ccoeff),conjg(Bcoeff),conjg(Rat))

! Cyclic permutation (4,1,2,3)
        call hgggg_integralfill(c4,c1,c2,c3)
        call hgggg_pppm(c4,c1,c2,c3,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(pppm(1,c3),pppm(2,c3),pppm(3,c3),pppm(4,c3),j)=hgggg_assemble(Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(3-pppm(1,c3),3-pppm(2,c3),3-pppm(3,c3),3-pppm(4,c3),j)=hgggg_assemble(conjg(Dcoeff),conjg(Ccoeff),conjg(Bcoeff),conjg(Rat))

        call hgggg_ppmm(c4,c1,c2,c3,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(ppmm(1,c2,c3),ppmm(2,c2,c3),ppmm(3,c2,c3),ppmm(4,c2,c3),j)=hgggg_assemble(Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(3-ppmm(1,c2,c3),3-ppmm(2,c2,c3),3-ppmm(3,c2,c3),3-ppmm(4,c2,c3),j)=hgggg_assemble(conjg(Dcoeff),conjg(Ccoeff),conjg(Bcoeff),conjg(Rat))

! Cyclic permutation (3,4,1,2)
        call hgggg_integralfill(c3,c4,c1,c2)
        call hgggg_pppm(c3,c4,c1,c2,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(pppm(1,c2),pppm(2,c2),pppm(3,c2),pppm(4,c2),j)=hgggg_assemble(Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(3-pppm(1,c2),3-pppm(2,c2),3-pppm(3,c2),3-pppm(4,c2),j)=hgggg_assemble(conjg(Dcoeff),conjg(Ccoeff),conjg(Bcoeff),conjg(Rat))

! Cyclic permutation (2,3,4,1)
        call hgggg_integralfill(c2,c3,c4,c1)
        call hgggg_pppm(c2,c3,c4,c1,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(pppm(1,c1),pppm(2,c1),pppm(3,c1),pppm(4,c1),j)=hgggg_assemble(Dcoeff,Ccoeff,Bcoeff,Rat)
        amp(3-pppm(1,c1),3-pppm(2,c1),3-pppm(3,c1),3-pppm(4,c1),j)=hgggg_assemble(conjg(Dcoeff),conjg(Ccoeff),conjg(Bcoeff),conjg(Rat))
      enddo

! Add helicities
      msq=zip
      do h1=1,2
      do h2=1,2
      do h3=1,2
      do h4=1,2
! DEBUG: removed subleading color contribution
!      msq=msq
!     & +two*xn**2*(abs(amp(h1,h2,h3,h4,1))**2+abs(amp(h1,h2,h3,h4,2))**2+abs(amp(h1,h2,h3,h4,3))**2)
! Full result
      msq=msq
     & +two*xn**2*(abs(amp(h1,h2,h3,h4,1))**2+abs(amp(h1,h2,h3,h4,2))**2+abs(amp(h1,h2,h3,h4,3))**2)
     & -four*(xn**2-three)/xn**2*abs(amp(h1,h2,h3,h4,1)+amp(h1,h2,h3,h4,2)+amp(h1,h2,h3,h4,3))**2
!      write(6,*) 'h1,h2,h3,h4,abs(amp(h1,h2,h3,h4,1))',h1,h2,h3,h4,abs(amp(h1,h2,h3,h4,3))
      enddo
      enddo
      enddo
      enddo
      
!      write(6,*) '|H1234 ++++|',abs(amp(2,2,2,2,1))
!      write(6,*) '|H1234 +++-|',abs(amp(2,2,2,1,1))
!      write(6,*) '|H1234 +-+-|',abs(amp(2,1,2,1,1))
!      write(6,*) '|H1234 ++--|',abs(amp(2,2,1,1,1))

! Apply overall factor
      msq=msq*V*(as**2*mtsq)**2/vevsq

      return
      end
      
      function pppm(i,c)
      implicit none
      integer pppm,i,c
      
      if (i==c) then
        pppm=1
      else
        pppm=2
      endif
      
      return
      end

      function ppmm(i,c1,c2)
      implicit none
      integer ppmm,i,c1,c2
      
      if ((i==c1) .or. (i==c2)) then
        ppmm=1
      else
        ppmm=2
      endif
      
      return
      end

