!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine hgggg_pmpm(p1,p2,p3,p4,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
c--- Coefficients of basis integrals in the helicity amplitude for
c----0 -> g+(p1) + g-(p2) + g+(p3) + g-(p4) + h
c--- with full top mass dependence
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/constants.f'
      include 'src/ggHgg_mass/hgggglabels.f'
      include 'src/Inc/zprods_decl.f'
      integer p1,p2,p3,p4
      complex(dp) :: Dcoeff(dmax),Ccoeff(cmax),Bcoeff(bmax),Rat,R(cmax),
     & pmpmD4x3x21,pmpmD1x23x4,pmpmD1x2x3,pmpmC3x4,pmpmC2x34,
     & pmpmC12x34,pmpmC1x234,pmpmB34,pmpmB234
      
      Dcoeff(:)=czip
      Ccoeff(:)=czip
      Bcoeff(:)=czip
      

      Dcoeff(d4x3x21)=pmpmD4x3x21(p1,p2,p3,p4,za,zb)
      Dcoeff(d4x1x23)=pmpmD4x3x21(p3,p2,p1,p4,za,zb)
      Dcoeff(d2x3x41)=pmpmD4x3x21(p1,p4,p3,p2,za,zb)
      Dcoeff(d2x1x43)=pmpmD4x3x21(p3,p4,p1,p2,za,zb)
      
      Dcoeff(d3x4x12)=pmpmD4x3x21(p2,p1,p4,p3,zb,za)
      Dcoeff(d3x2x14)=pmpmD4x3x21(p4,p1,p2,p3,zb,za)
      Dcoeff(d1x4x32)=pmpmD4x3x21(p2,p3,p4,p1,zb,za)
      Dcoeff(d1x2x34)=pmpmD4x3x21(p4,p3,p2,p1,zb,za)      
      
      Dcoeff(d1x23x4)=pmpmD1x23x4(p1,p2,p3,p4,za,zb)
      Dcoeff(d4x12x3)=pmpmD1x23x4(p3,p2,p1,p4,za,zb)
      Dcoeff(d2x34x1)=pmpmD1x23x4(p1,p4,p3,p2,za,zb)
      Dcoeff(d3x41x2)=pmpmD1x23x4(p3,p4,p1,p2,za,zb)

      Dcoeff(d1x2x3)=pmpmD1x2x3(p1,p2,p3,p4,za,zb)
      Dcoeff(d3x4x1)=pmpmD1x2x3(p3,p4,p1,p2,za,zb)
      Dcoeff(d2x3x4)=pmpmD1x2x3(p2,p3,p4,p1,zb,za)
      Dcoeff(d4x1x2)=pmpmD1x2x3(p4,p1,p2,p3,zb,za)


      Ccoeff(c3x4)=pmpmC3x4(p1,p2,p3,p4,za,zb)
      Ccoeff(c1x2)=pmpmC3x4(p3,p4,p1,p2,za,zb)
      Ccoeff(c4x1)=pmpmC3x4(p2,p3,p4,p1,zb,za)
      Ccoeff(c2x3)=pmpmC3x4(p4,p1,p2,p3,zb,za)
      
      Ccoeff(c2x34)=pmpmC2x34(p1,p2,p3,p4,za,zb)
      Ccoeff(c2x14)=pmpmC2x34(p3,p2,p1,p4,za,zb)
      Ccoeff(c4x32)=pmpmC2x34(p1,p4,p3,p2,za,zb)
      Ccoeff(c4x12)=pmpmC2x34(p3,p4,p1,p2,za,zb)

      Ccoeff(c3x41)=pmpmC2x34(p2,p3,p4,p1,zb,za)
      Ccoeff(c3x21)=pmpmC2x34(p4,p3,p2,p1,zb,za)
      Ccoeff(c1x43)=pmpmC2x34(p2,p1,p4,p3,zb,za)
      Ccoeff(c1x23)=pmpmC2x34(p4,p1,p2,p3,zb,za)

      Ccoeff(c12x34)=pmpmC12x34(p1,p2,p3,p4,za,zb,R(c12x34))
      Ccoeff(c23x41)=pmpmC12x34(p2,p3,p4,p1,zb,za,R(c23x41))
                                                            
      Ccoeff(c1x234)=pmpmC1x234(p1,p2,p3,p4,za,zb,R(c1x234))
      Ccoeff(c3x412)=pmpmC1x234(p3,p4,p1,p2,za,zb,R(c3x412))
      Ccoeff(c2x341)=pmpmC1x234(p2,p3,p4,p1,zb,za,R(c2x341))
      Ccoeff(c4x123)=pmpmC1x234(p4,p1,p2,p3,zb,za,R(c4x123))


      Bcoeff(b34)=pmpmB34(p1,p2,p3,p4,za,zb)
      Bcoeff(b12)=pmpmB34(p3,p4,p1,p2,za,zb)
      Bcoeff(b41)=pmpmB34(p2,p3,p4,p1,zb,za)
      Bcoeff(b23)=pmpmB34(p4,p1,p2,p3,zb,za)

      Bcoeff(b234)=pmpmB234(p1,p2,p3,p4,za,zb)
      Bcoeff(b412)=pmpmB234(p3,p4,p1,p2,za,zb)
      Bcoeff(b341)=pmpmB234(p2,p3,p4,p1,zb,za)
      Bcoeff(b123)=pmpmB234(p4,p1,p2,p3,zb,za)

      Bcoeff(b1234)=-Bcoeff(b34)-Bcoeff(b12)-Bcoeff(b41)-Bcoeff(b23)
     & -Bcoeff(b234)-Bcoeff(b412)-Bcoeff(b341)-Bcoeff(b123)

      
!      Rat=
!     & (pmpmC12x34m2(p1,p2,p3,p4,za,zb)
!     & +pmpmC1x234m2(p1,p2,p3,p4,za,zb)
!     & +pmpmC1x234m2(p3,p4,p1,p2,za,zb)
!     & +pmpmC12x34m2(p2,p3,p4,p1,zb,za)
!     & +pmpmC1x234m2(p4,p1,p2,p3,zb,za)
!     & +pmpmC1x234m2(p2,p3,p4,p1,zb,za))/two

      Rat=0.5_dp*(R(c12x34)+R(c23x41)+R(c1x234)
     & +R(c3x412)+R(c2x341)+R(c4x123))
      return
      end
