!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine hgggg_pppm(p1,p2,p3,p4,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
c--- Coefficients of basis integrals in the helicity amplitude for
c----0 -> g+(p1) + g+(p2) + g+(p3) + g-(p4) + h
c--- with full top mass dependence
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/constants.f'
      include 'src/ggHgg_mass/hgggglabels.f'
      include 'src/Inc/zprods_decl.f'
      integer p1,p2,p3,p4
      complex(dp) :: Dcoeff(dmax),Ccoeff(cmax),Bcoeff(bmax),Rat,R(cmax),
     & pppmD1x2x34,pppmD1x4x32,pppmD2x1x43,pppmD2x34x1,pppmD4x3x21,
     & pppmD1x23x4,pppmD2x3x4,pppmD1x2x3,pppmD3x4x1,
     & pppmC3x4,pppmC2x34,pppmC1x43,pppmC4x123,pppmC1x234,ppmpC2x341,
     & pppmC12x34,pppmB34,pppmB234
      
      Dcoeff(:)=czip
      Ccoeff(:)=czip
      Bcoeff(:)=czip
      

      Dcoeff(d1x2x34)=pppmD1x2x34(p1,p2,p3,p4,za,zb)
      Dcoeff(d3x2x14)=pppmD1x2x34(p3,p2,p1,p4,za,zb)

      Dcoeff(d1x4x32)=pppmD1x4x32(p1,p2,p3,p4,za,zb)
      Dcoeff(d3x4x12)=pppmD1x4x32(p3,p2,p1,p4,za,zb)

      Dcoeff(d2x1x43)=pppmD2x1x43(p1,p2,p3,p4,za,zb)
      Dcoeff(d2x3x41)=pppmD2x1x43(p3,p2,p1,p4,za,zb)

      Dcoeff(d2x34x1)=pppmD2x34x1(p1,p2,p3,p4,za,zb)
      Dcoeff(d3x41x2)=pppmD2x34x1(p3,p2,p1,p4,za,zb)

      Dcoeff(d4x3x21)=pppmD4x3x21(p1,p2,p3,p4,za,zb)
      Dcoeff(d4x1x23)=pppmD4x3x21(p3,p2,p1,p4,za,zb)
      
      Dcoeff(d1x23x4)=pppmD1x23x4(p1,p2,p3,p4,za,zb)
      Dcoeff(d4x12x3)=pppmD1x23x4(p3,p2,p1,p4,za,zb)
      
      Dcoeff(d2x3x4)=pppmD2x3x4(p1,p2,p3,p4,za,zb)
      Dcoeff(d4x1x2)=pppmD2x3x4(p3,p2,p1,p4,za,zb)

      Dcoeff(d1x2x3)=pppmD1x2x3(p1,p2,p3,p4,za,zb)

      Dcoeff(d3x4x1)=pppmD3x4x1(p1,p2,p3,p4,za,zb)

      
      Ccoeff(c3x4)=pppmC3x4(p1,p2,p3,p4,za,zb)
      Ccoeff(c4x1)=pppmC3x4(p3,p2,p1,p4,za,zb)
      
      Ccoeff(c2x34)=pppmC2x34(p1,p2,p3,p4,za,zb)
      Ccoeff(c2x14)=pppmC2x34(p3,p2,p1,p4,za,zb)
      
      Ccoeff(c1x43)=pppmC1x43(p1,p2,p3,p4,za,zb)
      Ccoeff(c3x41)=pppmC1x43(p3,p2,p1,p4,za,zb)
      
      Ccoeff(c4x123)=pppmC4x123(p1,p2,p3,p4,za,zb,R(c4x123))
                                                            
      Ccoeff(c1x234)=pppmC1x234(p1,p2,p3,p4,za,zb,R(c1x234))
      Ccoeff(c3x412)=pppmC1x234(p3,p2,p1,p4,za,zb,R(c3x412))
                                                            
      Ccoeff(c2x341)=ppmpC2x341(p1,p2,p3,p4,za,zb,R(c2x341))
                                                            
      Ccoeff(c12x34)=pppmC12x34(p1,p2,p3,p4,za,zb,R(c12x34))
      Ccoeff(c23x41)=pppmC12x34(p3,p2,p1,p4,za,zb,R(c23x41))


      Bcoeff(b34)=pppmB34(p1,p2,p3,p4,za,zb)
      Bcoeff(b41)=pppmB34(p3,p2,p1,p4,za,zb)
      
      Bcoeff(b234)=pppmB234(p1,p2,p3,p4,za,zb)
      Bcoeff(b412)=pppmB234(p3,p2,p1,p4,za,zb)
      Bcoeff(b341)=-pppmB234(p2,p3,p1,p4,za,zb)
     & -pppmB234(p2,p1,p3,p4,za,zb)
      
      Bcoeff(b1234)=-Bcoeff(b34)-Bcoeff(b41)
     & -Bcoeff(b234)-Bcoeff(b412)-Bcoeff(b341)
      
!      Rat=
!     & (pppmC12x34m2(p1,p2,p3,p4,za,zb)
!     & +pppmC12x34m2(p3,p2,p1,p4,za,zb)
!     & +pppmC1x234m2(p1,p2,p3,p4,za,zb)
!     & +pppmC1x234m2(p3,p2,p1,p4,za,zb)
!     & +pppmC4x123m2(p1,p2,p3,p4,za,zb)
!     & +ppmpC2x341m2(p1,p2,p3,p4,za,zb))/two

      Rat=0.5_dp*(R(c12x34)+R(c23x41)
     &           +R(c1x234)+R(c3x412)+R(c4x123)+R(c2x341))
      return
      end

