!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function pmpmC3x4(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^- 3_g^+ 4_g^- +H
!     Implementation of Eq.~(6.9) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      integer p1,p2,p3,p4
      real(dp):: s12,s13,s14,s23,s24,s34,s234,s134,
     & s13ps23,s23ps34,s14ps24,s14ps34
      complex(dp):: pmpmC3x4,zab2,zab

      zab(p1,p2,p3)=za(p1,p2)*zb(p2,p3)
      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)

      s234=s23+s24+s34
      s134=s13+s14+s34
      s13ps23=s13+s23
      s23ps34=s23+s34
      s14ps24=s14+s24
      s14ps34=s14+s34

      pmpmC3x4=-2._dp*s34
     & /(s12*zab2(p3,p1,p2,p4)**3*(za(p1,p3)*zb(p2,p4))**2)
     & *(zab(p3,p1,p4)**3*(s24*s14ps24+s12*s23ps34)
     &  +zab(p3,p1,p4)**2*zab(p3,p2,p4)
     & *(s12**2-s14*s14ps24+s12*(3._dp*s234-5._dp*s24))
     & +zab(p3,p2,p4)**3*(s13*s13ps23+s12*s14ps34)
     & +zab(p3,p1,p4)*zab(p3,p2,p4)**2
     & *(s12**2-s23*s13ps23+s12*(3._dp*s134-5._dp*s13)))
      return
      end
