!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function ppppD1x2x3(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^+ 3_g^+ 4_g^+ +H
!     Implementation of Eq.~(4.8) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      include 'src/ggHgg_mass/mtsq.f'
      include 'src/ggHgg_mass/Cred.f'
      include 'src/ggHgg_mass/I5to4.f'
      integer::p1,p2,p3,p4
      complex(dp)::ppppD1x2x3,ppppE1x2x3x4,ppppE4x1x2x3,fac
      real(dp) s12,s13,s14,s23,s24,s34,s1234
      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      s1234=s12+s13+s14+s23+s24+s34

      fac=(s1234-4._dp*mtsq)/(za(p1,p2)*za(p2,p3)*za(p3,p4)*za(p4,p1))
      ppppE1x2x3x4=mtsq*fac*zb(p1,p2)*za(p2,p3)*zb(p3,p4)*za(p4,p1)
      ppppE4x1x2x3=mtsq*fac*zb(p4,p1)*za(p1,p2)*zb(p2,p3)*za(p3,p4)

      ppppD1x2x3=-0.5_dp*fac*s12*s23
     & +Cred(1,I5to4(p4,p1,p2))*ppppE4x1x2x3
     & +Cred(5,I5to4(p1,p2,p3))*ppppE1x2x3x4
      return
      end
