      subroutine sio2vqq(fi,fo,vc, cl, cr, vertex)
c
c This subroutine computes an amplitude of the fermion-fermion-vector
c coupling.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c
c output:
c       complex vertex         : amplitude                     <fo|v|fi>
c     
      implicit none
      double complex fi(6),fo(6),vc(6),vertex

      double precision rZero, rOne, cl ,cr, pf(0:3)
      parameter( rZero = 0.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

      pf(0) = dble( fi(5))
      pf(1) = dble( fi(6))
      pf(2) = dimag(fi(6))
      pf(3) = dimag(fi(5))

         vertex=(cl*fi(1)*fo(1) + cl*fi(2)*fo(2) + 
     -    cr*fi(3)*fo(3) + cr*fi(4)*fo(4))*
     -  (pf(0)*vc(1) - pf(1)*vc(2) - 
     -    pf(2)*vc(3) - pf(3)*vc(4))

      return
      end
